/*
 * MessageBox.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class MessageBox extends JFrame 
{
  
  static JPanel buttonsPanel = new JPanel();
  static ButtonGroup buttonsButtonGroup = new ButtonGroup();
  static JRadioButton okRadioButton = new JRadioButton();
  static JRadioButton okCancelRadioButton = new JRadioButton();
  static JRadioButton yesNoCancelRadioButton = new JRadioButton();
  static JRadioButton yesNoRadioButton = new JRadioButton();
  static JButton showButton = new JButton();
  static JPanel iconPanel = new JPanel();
  static ButtonGroup iconButtonGroup = new ButtonGroup();
  static JRadioButton noneRadioButton = new JRadioButton();
  static JRadioButton informationRadioButton = new JRadioButton();
  static JRadioButton errorRadioButton = new JRadioButton();
  static JRadioButton warningRadioButton = new JRadioButton();
  static JRadioButton questionRadioButton = new JRadioButton();
  static JPanel messagePanel = new JPanel();
  static JScrollPane messageScrollPane = new JScrollPane();
  static JTextArea messageTextArea = new JTextArea();

  static int buttonType;
  static int iconType;

  public static void main(String args[]) 
  {
  	// construct frame
    new MessageBox().show();
    // click on radio buttons to initialize values
    okRadioButton.doClick();
    noneRadioButton.doClick();

  }
  
  public MessageBox() 
  {
  	// create frame
  	setTitle("Message Box Example");
  	setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
   	getContentPane().setLayout(new GridBagLayout());
   	
   	// position controls
   	GridBagConstraints gridConstraints;
    buttonsPanel.setLayout(new GridBagLayout());
		buttonsPanel.setBorder(BorderFactory.createTitledBorder("Button(s)"));
    okRadioButton.setText("OK Only");
		buttonsButtonGroup.add(okRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.anchor = GridBagConstraints.WEST;
		buttonsPanel.add(okRadioButton, gridConstraints);
		okRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		buttonsRadioButtonActionPerformed(e);
  		}
		});
    okCancelRadioButton.setText("OK/Cancel");
		buttonsButtonGroup.add(okCancelRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		gridConstraints.anchor = GridBagConstraints.WEST;
		buttonsPanel.add(okCancelRadioButton, gridConstraints);
		okCancelRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		buttonsRadioButtonActionPerformed(e);
  		}
		});
    yesNoCancelRadioButton.setText("Yes/No/Cancel");
		buttonsButtonGroup.add(yesNoCancelRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 2;
		gridConstraints.anchor = GridBagConstraints.WEST;
		buttonsPanel.add(yesNoCancelRadioButton, gridConstraints);
		yesNoCancelRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		buttonsRadioButtonActionPerformed(e);
  		}
		});
    yesNoRadioButton.setText("Yes/No");
		buttonsButtonGroup.add(yesNoRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 3;
		gridConstraints.anchor = GridBagConstraints.WEST;
		buttonsPanel.add(yesNoRadioButton, gridConstraints);
		yesNoRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		buttonsRadioButtonActionPerformed(e);
  		}
		});

		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		getContentPane().add(buttonsPanel, gridConstraints);

		showButton.setText("Show Message Box");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		getContentPane().add(showButton, gridConstraints);
		showButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		showButtonActionPerformed(e);
  		}
		});

    iconPanel.setLayout(new GridBagLayout());
		iconPanel.setBorder(BorderFactory.createTitledBorder("Icon"));
    noneRadioButton.setText("None");
		iconButtonGroup.add(noneRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.anchor = GridBagConstraints.WEST;
		iconPanel.add(noneRadioButton, gridConstraints);
		noneRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		iconRadioButtonActionPerformed(e);
  		}
		});
    informationRadioButton.setText("Information");
		iconButtonGroup.add(informationRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		gridConstraints.anchor = GridBagConstraints.WEST;
		iconPanel.add(informationRadioButton, gridConstraints);
		informationRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		iconRadioButtonActionPerformed(e);
  		}
		});
    errorRadioButton.setText("Error");
		iconButtonGroup.add(errorRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 2;
		gridConstraints.anchor = GridBagConstraints.WEST;
		iconPanel.add(errorRadioButton, gridConstraints);
		errorRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		iconRadioButtonActionPerformed(e);
  		}
		});
    warningRadioButton.setText("Warning");
		iconButtonGroup.add(warningRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 3;
		gridConstraints.anchor = GridBagConstraints.WEST;
		iconPanel.add(warningRadioButton, gridConstraints);
		warningRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		iconRadioButtonActionPerformed(e);
  		}
		});
    questionRadioButton.setText("Question");
		iconButtonGroup.add(questionRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 4;
		gridConstraints.anchor = GridBagConstraints.WEST;
		iconPanel.add(questionRadioButton, gridConstraints);
		questionRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		iconRadioButtonActionPerformed(e);
  		}
		});
		
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 1;
		gridConstraints.gridy = 0;
		getContentPane().add(iconPanel, gridConstraints);

    messagePanel.setLayout(new GridBagLayout());
		messagePanel.setBorder(BorderFactory.createTitledBorder("Message"));
    messageScrollPane.setPreferredSize(new Dimension(200, 100));
    messageTextArea.setText("");
   	messageTextArea.setLineWrap(true);
   	messageTextArea.setWrapStyleWord(true);
    messageScrollPane.setViewportView(messageTextArea);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		messagePanel.add(messageScrollPane, gridConstraints);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 1;
		gridConstraints.gridy = 1;
		getContentPane().add(messagePanel, gridConstraints);

    pack();
  	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
 
  }
	
	private void buttonsRadioButtonActionPerformed(ActionEvent e)
  {
  	String caption;
  	caption = e.getActionCommand();
    if (caption.equals("OK Only"))
    {
     	buttonType = JOptionPane.DEFAULT_OPTION;
    }
    else if (caption.equals("OK/Cancel"))
    {
     	buttonType = JOptionPane.OK_CANCEL_OPTION;
    }
    else if (caption.equals("Yes/No/Cancel"))
    {
    	buttonType = JOptionPane.YES_NO_CANCEL_OPTION;
    }
    else if (caption.equals("Yes/No"))
    {
      buttonType = JOptionPane.YES_NO_OPTION;
    }
  }

	private void iconRadioButtonActionPerformed(ActionEvent e)
  {
  	String caption;
  	caption = e.getActionCommand();
    if (caption.equals("None"))
    {
     	iconType = JOptionPane.PLAIN_MESSAGE;
    }
    else if (caption.equals("Information"))
    {
     	iconType = JOptionPane.INFORMATION_MESSAGE;
    }
    else if (caption.equals("Error"))
    {
     	iconType = JOptionPane.ERROR_MESSAGE;
    }
    else if (caption.equals("Warning"))
    {
     	iconType = JOptionPane.WARNING_MESSAGE;
    }
    else if (caption.equals("Question"))
    {
     	iconType = JOptionPane.QUESTION_MESSAGE;
    }
  }

	private void showButtonActionPerformed(ActionEvent e)
  {
    // display message box
    int rtn;
    String message = "";
    if (messageTextArea.getText().equals(""))
    {
    	rtn = JOptionPane.showConfirmDialog(null, "No message", "Message Box Example", buttonType, iconType);
    }
    else
    {
    	rtn = JOptionPane.showConfirmDialog(null, messageTextArea.getText(), "Message Box Example", buttonType, iconType);
    }
    switch (rtn)
    {
      case (JOptionPane.CLOSED_OPTION):
        message = "Window closed - no button pressed";
        break;
      case (JOptionPane.OK_OPTION):
        message = "OK/Yes button pressed";
        break;
      case (JOptionPane.NO_OPTION):
        message = "No button pressed";
        break;
      case (JOptionPane.CANCEL_OPTION):
        message = "Cancel button pressed";
        break;
    }
    JOptionPane.showConfirmDialog(null, message, "Message Box Results", JOptionPane.PLAIN_MESSAGE, JOptionPane.DEFAULT_OPTION);
  }

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }
}
