/*
 * Tray.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

public class Tray extends JFrame 
{
	
	static JLabel lengthLabel = new JLabel();
	static JLabel widthLabel = new JLabel();
	static JLabel cutLabel = new JLabel();
	static JLabel volumeLabel = new JLabel();
	static JTextField lengthTextField = new JTextField();
	static JTextField widthTextField = new JTextField();
	static JTextField cutTextField = new JTextField();
	static JTextField volumeTextField = new JTextField();
	static JButton computeButton = new JButton();

  public static void main(String args[]) 
  {
  	//construct frame
    new Tray().show();
  }

  public Tray() 
  {
  	// code to build the form
    setTitle("Tray Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    lengthLabel.setText("Length (L)");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(lengthLabel, gridConstraints);
    widthLabel.setText("Width (W)");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(widthLabel, gridConstraints);
    cutLabel.setText("Cut Size (X)");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    getContentPane().add(cutLabel, gridConstraints);
    volumeLabel.setText("Volume");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 4;
    getContentPane().add(volumeLabel, gridConstraints);
    
    lengthTextField.setText("");
    lengthTextField.setColumns(10);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    getContentPane().add(lengthTextField, gridConstraints);
    lengthTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		lengthTextFieldActionPerformed(e);
    	}
    });
    widthTextField.setText("");
    widthTextField.setColumns(10);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(widthTextField, gridConstraints);
    widthTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		widthTextFieldActionPerformed(e);
    	}
    });
    cutTextField.setText("");
    cutTextField.setColumns(10);
    cutTextField.setEditable(false);
    cutTextField.setFocusable(false);
    cutTextField.setHorizontalAlignment(SwingConstants.CENTER);
    cutTextField.setBackground(Color.WHITE);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 3;
    getContentPane().add(cutTextField, gridConstraints);
    volumeTextField.setText("");
    volumeTextField.setColumns(10);
    volumeTextField.setEditable(false);
    volumeTextField.setFocusable(false);
    volumeTextField.setHorizontalAlignment(SwingConstants.CENTER);
    volumeTextField.setBackground(Color.WHITE);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    getContentPane().add(volumeTextField, gridConstraints);

    computeButton.setText("Compute Cut Size");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.gridwidth = 2;
    getContentPane().add(computeButton, gridConstraints);
    computeButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		computeButtonActionPerformed(e);
    	}
    });
    pack();
   	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
	
  private void lengthTextFieldActionPerformed(ActionEvent e)
  {
  	lengthTextField.transferFocus();
  }

  private void widthTextFieldActionPerformed(ActionEvent e)
  {
  	computeButton.doClick();
  }
  

	private void computeButtonActionPerformed(ActionEvent e)
	{
		double l;
    double w;
    double x, xMax;
    double volume, volMax;
    double xBest = 0.0;
    
    // Read L and W
    l = Double.valueOf(lengthTextField.getText()).doubleValue();
    w = Double.valueOf(widthTextField.getText()).doubleValue();
		if (l <= 0 || w <= 0)
		{
			JOptionPane.showConfirmDialog(null, "L and W must both be positive", "Invalid values", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE);
 			return;
 		}
    // Largest cut is one-half of smallest side
    if (l > w)
    {
      xMax = w / 2;
    }
    else
    {
      xMax = l / 2;
    }
    // Go through 1000 possible cuts from 0 to xMax
    // Find largest volume
    volMax = 0;
    for (x = 0; x <= xMax; x += xMax / 1000)
    {
      volume = x * (l - 2 * x) * (w - 2 * x);
      if (volume > volMax)
      {
        xBest = x;
        volMax = volume;
    	}
  	}
    // Display best values
    cutTextField.setText(new DecimalFormat("0.000").format(xBest));
    volumeTextField.setText(new DecimalFormat("0.000").format(volMax));
	}

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }


}
